(define (fib x)
    (cond ((eq? x 0) 0)
    ((eq? x 1) 1)
    (#t (+ (fib (- x 1)) (fib (- x 2))))))

(define (fact x)
    (cond ((eq? x 1) 1)
    (#t (* x (fact (- x 1))))))

(define (null? l) (eq? l '()))

(define (merge-lists l1 l2)
	(cond ((null? l1) l2)
		((null? l2) l1)
		((< (car l1) (car l2)) (cons (car l1) (merge-lists (cdr l1) l2)))
		(#t (cons (car l2) (merge-lists l1 (cdr l2))))))

(define (split-half l l1 l2)
	(cond ((null? l) (cons l1 l2))
	((null? (cdr l)) (split-half (cdr l) (cons (car l) l1) l2))
	(#t (split-half (cdr (cdr l))
		(cons (car l) l1)
		(cons (car (cdr l)) l2)))))

(define (merge-sort lst)
	(cond ((null? lst) ())
	((null? (cdr lst)) lst)
	(#t (let ((lsts (split-half lst '() '())))
		(merge-lists (merge-sort (car lsts))
		(merge-sort (cdr lsts)))))))

(define (map arg fn) (cond ((null? arg) ())
			   (#t (merge-lists ((fn (car arg))) (map (cdr arg) fn)))))

(map (7 8 9) (lambda (x) (fib x)))
(map (7 8 9) (lambda (x) (fact x)))
(fact 5)
(fib 10)
(fib 16)
(merge-sort (5 3 4 2 1))
(merge-sort (39 16 22 31 28 20 42 37 11))
(map ((8 5 3 9 2) (0 4 2 6 1) (3 5 4 1 9)) (lambda (array) (merge-sort array)))
